# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/*
 *  lexer.l,v 1.30 1994/01/25 18:47:59 jch Exp
 */

/* Gated Release 3.1 */
/* Copyright (c) 1990,1991,1992,1993 by Cornell University. All rights reserved. */
/* Refer to Particulars and other Copyright notices at the end of this file. */

#define	GATED_LEXER
#define	INCLUDE_STAT
#define	INCLUDE_TIME

#include "include.h"
#include "ctype.h"
#include "parse.h"
#include "parser.h"

#define	printf(fmt, arg)	trace_tf(trace_global, TR_PARSE, 0, (fmt, arg));
#undef	yywrap
#define	yywrap	parse_eof

#define	parse_newname(fip)	{ \
    register char *new_name; \
    parse_filename = (new_name = (char *) rindex((fip)->fi_name, '/')) ? ++new_name : (fip)->fi_name; \
    }

#ifdef	YY_START
#define	YBEGIN(state) \
do { \
    trace_tf(trace_global, \
	     TR_PARSE, \
	     0, \
	     ("yylex: %s TRANSITION from %u to %u at %s:%u", \
	      parse_where(), \
	      YY_START, \
	      (state), \
	      __FILE__, \
	      __LINE__)); \
    BEGIN (state); \
} while (0)
#else	/* YY_START */
#define	YBEGIN(state) \
do { \
    trace_tf(trace_global, \
	     TR_PARSE, \
	     0, \
	     ("yylex: %s TRANSITION to %u at %s:%u", \
	      parse_where(), \
	      (state), \
	      __FILE__, \
	      __LINE__)); \
    BEGIN (state); \
} while (0)
#endif	/* YY_START */
    
#define	ATOI(str, store) \
	{ \
	    register char *Xcp = (str); \
	    register u_long Xacc = 0; \
	    while (*Xcp) { \
		Xacc = (Xacc << 3) + (Xacc << 1) + *Xcp++ - '0'; \
	    } \
	    (store) = Xacc; \
	}

#if	defined(FLEX_SCANNER) && defined(YY_CURRENT_BUFFER)
#define	FLEX_BUFFER_STATE
#define	SAVE_YY_STATE(fip)	(fip)->fi_state = YY_CURRENT_BUFFER
#define	NEW_YY_FILE(fip, file)	yy_switch_to_buffer(yy_create_buffer(yyin, YY_BUF_SIZE))
#define	DELETE_YY_STATE(fip) yy_delete_buffer(YY_CURRENT_BUFFER)
#define	SET_YY_STATE(fip)	yy_switch_to_buffer((fip)->fi_state)
#else
#define	SAVE_YY_STATE(fip)	(fip)->fi_FILE = yyin
#define	NEW_YY_FILE(fip, file)	(fip)->fi_FILE = (file)
#define	DELETE_YY_STATE(fip)	fip->fi_FILE = NULL
#define	SET_YY_STATE(fip)	yyin = (fip)->fi_FILE
#endif

struct fi_info {
    char *fi_name;			/* File name */
    int fi_lineno;			/* Line number */
#ifdef	FLEX_BUFFER_STATE
    YY_BUFFER_STATE fi_state;		/* Input buffer state */
#else	/* FLEX_BUFFER_STATE */
    FILE *fi_FILE;			/* File pointer */
#endif	/* FLEX_BUFFER_STATE */
};

static struct fi_info parse_fi[FI_MAX+1];		/* Table of input files */
static int fi_file = 0;				/* Index into file table */
char *parse_directory = (char *) 0;

PROTOTYPE(parse_include,
	  static int,
	  (char *));
PROTOTYPE(parse_eof,
	  static int,
	  (void));

#ifdef	FLEX_SCANNER

#define	YYTEXT	yytext

int yylineno = 0;

#undef	YY_INPUT
#define	YY_INPUT(buf, result, max_size) \
{ \
    (result) = read(fileno(yyin), (buf), (size_t) (max_size)); \
    if ((result) < 0) { \
	YY_FATAL_ERROR("flex: read: %m"); \
    } else if ((result) == 0) { \
	(result) = YY_NULL; \
    } \
}

#define	YY_NEWLINE	yylineno++

#ifdef	YY_FATAL_ERROR
#undef	YY_FATAL_ERROR
#endif	/* YY_FATAL_ERROR */
#define	YY_FATAL_ERROR(msg)	{ trace_log_tf(trace_global, 0, LOG_ERR, (msg)); task_quit(EINVAL); }

#else	/* FLEX_SCANNER */

#define	YYTEXT	(char *) yytext
#define	YY_NEWLINE

#endif	/* FLEX_SCANNER */

# define CONFIG 2
# define PP 4
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
{
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s COMMENT",
				  parse_where()));
		}
break;
case 2:
{
			char ttchar;
			static const char *search = "*/";
			const char *sp = search;
			char buf[BUFSIZ];

			strcpy(buf, parse_where());

			while ((ttchar = input())) {
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("lex: %s comment: %c(%x)",
				      parse_where(),
				      ttchar,
				      ttchar));
			    if (ttchar == (char) EOF) {
				(void) sprintf(parse_error, "lex: unterminated C constant at %s",
					       buf);
				return L_ERROR;
			    } else if (ttchar == *sp) {
				if (!*++sp) {
				    break;
				}
			    } else {
				if (ttchar == '\n') {
				    YY_NEWLINE;
				}
				sp = search;
			    }
			}
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s COMMENT",
				  parse_where()));
		}
break;
case 3:
	{ ; }
break;
case 4:
{
			yylval.str.ptr = YYTEXT;
			yylval.str.len = yyleng;
			yylval.str.type = L_STRING;
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s L_STRING: %s length %d",
				  parse_where(),
				  yylval.str.ptr,
				  yylval.str.len));
			return yylval.str.type;
		}
break;
case 5:
{
			yylval.str.ptr = YYTEXT;
			yylval.str.len = yyleng;
			yylval.str.type = L_STRING;
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s L_STRING: %s length %d",
				  parse_where(),
				  yylval.str.ptr,
				  yylval.str.len));
			return yylval.str.type;
		}
break;
case 6:
{
			bits *key;

			yylval.str.ptr = YYTEXT;
			yylval.str.len = yyleng;
			key = parse_keyword(YYTEXT);
			if (key) {
			    yylval.str.type = key->t_bits;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("lex: %s KEYWORD: %s (%u)",
				      parse_where(),
				      YYTEXT,
				      key->t_bits));
			} else {
			    yylval.str.type = L_KEYWORD;
			    trace_tf(trace_global,
				     TR_PARSE,
				     0,
				     ("lex: %s L_KEYWORD: %s length: %d",
				      parse_where(),
				      yylval.str.ptr,
				      yylval.str.len));
			}
			return yylval.str.type;
		}
break;
case 7:
{
			YY_NEWLINE;
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s L_EOS",
				  parse_where()));
			YBEGIN(CONFIG);
			return L_EOS;
		}
break;
case 8:
{
			YY_NEWLINE;
		}
break;
case 9:
{
    			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s L_EOS",
				  parse_where()));
			return L_EOS;
		}
break;
case 10:
{
    			register char *cp = YYTEXT;
			char *name;

			while (*cp++ != '"') ;
			name = cp;
			while (*cp != '"') {
			    cp++;
			}
			*cp = (char) 0;
			cp = name;

#ifdef	FLAT_FS
			name = task_mem_strdup((task *) 0, cp);
#else	/* FLAT_FS */
			switch (*cp) {
			case '/':
			    name = task_mem_strdup((task *) 0,
						   cp);
			    break;

			default:
			    name = task_mem_malloc((task *) 0,
						   (size_t) (strlen(cp) + strlen(parse_directory) + 2));

			    (void) strcpy(name, parse_directory);
			    (void) strcat(name, "/");
			    (void) strcat(name, cp);
			}
#endif	/* FLAT_FS */
			
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s INCLUDE '%s'",
				  parse_where(),
				  name));

			/* Count the newline in this file */
    			YY_NEWLINE;

			if (parse_include(name)) {
			    return L_ERROR;
			}
			/* String is freed by parse_eof() */
}
break;
case 11:
{
    			register char *cp = YYTEXT;
			char *name;
#ifndef	NO_STAT
			struct stat stbuf;
#endif	/* NO_STAT */

			while (*cp++ != '"') ;
			name = cp;
			while (*cp != '"') {
			    cp++;
			}
			*cp-- = (char) 0;
			if (*cp == '/') {
			    *cp-- = (char) 0;
			}

#ifndef	NO_STAT
			if (stat(name, &stbuf) < 0) {
			    (void) sprintf(parse_error, "stat(%s): %m",
					   name);
			    return L_ERROR;
			}

			switch (stbuf.st_mode & S_IFMT) {
			case S_IFDIR:
			    break;

			default:
			    (void) sprintf(parse_error, "%s is not a directory",
					   name);
			    return L_ERROR;
			}
#endif	/* NO_STAT */

			if (parse_directory) {
			    task_mem_free((task *) 0,
					  parse_directory);
			}
			parse_directory = task_mem_strdup((task *) 0,
							  name);
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s included file prefeix now %s",
				  parse_where(),
				  parse_directory));
}
break;
case 12:
{
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s '%s'",
				  parse_where(),
				  YYTEXT));
			YBEGIN(PP);
			return (char) *yytext;
		}
break;
case 13:
{
			yylval.str.ptr = YYTEXT;
			yylval.str.len = yyleng;
			yylval.str.type = L_HNAME;
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s HNAME: %s length %d",
				  parse_where(),
				  yylval.str.ptr,
				  yylval.str.len));
			return yylval.str.type;
		}
break;
case 14:
{
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s '%s'",
				  parse_where(),
				  YYTEXT));
			return (char) *yytext;
		}
break;
case 15:
{
			ATOI(YYTEXT, yylval.num);
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s L_NUMBER: %d",
				  parse_where(),
				  yylval.num));
			return L_NUMBER;
		}
break;
case 16:
{
			char usecs[7];
			register int i;
			register char *cp = YYTEXT;

			for (i = 0; i < 6; i++) {
			    usecs[i] = *cp ? *cp++ : '0';
			}

			ATOI(usecs, yylval.num);
			trace_tf(trace_global,
				 TR_PARSE,
				 0,
				 ("lex: %s L_USEC: %u",
				  parse_where(),
				  yylval.num));
			return L_USEC;
		}
break;
case 17:
{
#define	atox(c)	(isdigit(c) ? (c - '0') : ( isupper(c) ? (c - 'A' + 10) : (c - 'a' + 10) ))
#ifdef	PROTO_ISO
			register int i = 0;
			register u_char acc = 0;
			register char *cp;
			register byte *dp;

			for (cp = YYTEXT; *cp; cp++) {
			    if (*cp != '.') {
				i++;
			    }
			}
			yylval.hex.len = (i + 1)/2;
			yylval.hex.ptr = (byte *) task_mem_malloc((task *) 0, yylval.hex.len);
			yylval.hex.type = L_ISOADDR;
			dp = yylval.hex.ptr;
			cp = YYTEXT;

			/* Pick up string ignoring trailing dots */
			i = 0;
			do {
			    switch (*cp) {
			    case '.':
				/* Ignore dots */
				break;

			    case 0:
				if (i) {
				    /* Stuff the trailing nibble */

				    *dp = acc;
				}
				/* This will cause the loop to break */
				cp = (char *) 0;
				break;

			    default:
				if ((i = !i)) {
				    /* First nibble */

				    acc = atox(*cp) << 4;
				} else {
				    /* Second nibble */

				    *dp++ = acc | atox(*cp);
				}
				break;
			    }			    
			} while (cp++);

			if (TRACE_TF(trace_global, TR_PARSE)) {
			    tracef("lex: %s L_ISOADDR: length %d ",
				   parse_where(),
				   yylval.hex.len);
			    for (i = 0; i < yylval.hex.len; i++) {
				tracef("%02x",
				       yylval.hex.ptr[i]);
			    }
			    trace_only_tf(trace_global,
					  0,
					  (NULL));
			}
			return yylval.hex.type;
#else	/* PROTO_ISO */
			return (char) *yytext;
#endif	/* PROTO_ISO */
		    }
break;
case 18:
 {
    			int i;
    			char *cp;

			/* First count the number of octets */
			yylval.hex.len = 1;
			for (cp = YYTEXT; (cp = (char *) index(cp, '.')); *cp++ = (char) 0) {
			    yylval.hex.len++;
			}

			yylval.hex.ptr = (byte *) task_mem_malloc((task *) 0, yylval.hex.len);
			yylval.hex.type = L_OCTETSTRING;

			cp = YYTEXT;
			for (i = 0; i < yylval.hex.len; i++) {
			    ATOI(cp, yylval.hex.ptr[i]);
			    while (*cp++) ;
			}

			if (TRACE_TF(trace_global, TR_PARSE)) {
			    tracef("lex: %s L_OCTETSTRING: length %d ",
				   parse_where(),
				   yylval.hex.len);
			    for (i = 0; i < yylval.hex.len; i++) {
				tracef("%s%u",
				       i ? "." : "",
				       yylval.hex.ptr[i]);
			    }
			    trace_only_tf(trace_global,
					  0,
					  (NULL));
			}

			return L_OCTETSTRING;
		    }
break;
case 19:
{
			int i = 0;
			char *cp;
			byte *dp;

			for (cp = YYTEXT; *cp; cp++) {
			    if (*cp != '-') {
				i++;
			    }
			}
			yylval.hex.len = (i + 1)/2;
			yylval.hex.ptr = (byte *) task_mem_malloc((task *) 0, yylval.hex.len);
			dp = yylval.hex.ptr;
			cp = YYTEXT;
			yylval.hex.type = L_HEXSTRING;
			for (; *cp; cp++, dp++) {
			    if (*cp == '-') {
				cp++;
			    }
			    *dp = atox(*cp) << 4;
			    cp++;
			    if (*cp == '-') {
				cp++;
			    }
			    *dp |= atox(*cp);
			}
			if (TRACE_TF(trace_global, TR_PARSE)) {
			    tracef("lex: %s L_HEXSTRING: length %d ",
				   parse_where(),
				   yylval.hex.len);
			    for (i = 0; i < yylval.hex.len; i++) {
				tracef("%02x",
				       yylval.hex.ptr[i]);
			    }
			    trace_only_tf(trace_global,
					  0,
					  (NULL));
			}
			return yylval.hex.type;
		    }
break;
case 20:
{
			int i = yyleng - 2;
    			char *cp = YYTEXT + 2;
			byte *dp;

			yylval.hex.len = (i + 1)/2;
			yylval.hex.ptr = (byte *) task_mem_malloc((task *) 0, yylval.hex.len);
			dp = yylval.hex.ptr;
			yylval.hex.type = L_HEXSTRING;
			for (; *cp; cp += 2, dp++) {
			    *dp = (atox(cp[0]) << 4) | atox(cp[1]);
			}
			if (TRACE_TF(trace_global, TR_PARSE)) {
			    tracef("lex: %s L_HEXSTRING: length %d 0x",
				   parse_where(),
				   yylval.hex.len);
			    for (i = 0; i < yylval.hex.len; i++) {
				tracef("%02x",
				       yylval.hex.ptr[i]);
			    }
			    trace_only_tf(trace_global,
					  0,
					  (NULL));
			}
			return yylval.hex.type;
		    }
break;
case 21:
	{
    			(void) sprintf(parse_error, "unrecognized character: `%s'",
				       YYTEXT);
			return L_ERROR;
		}
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */

#if	!defined(FLEX_SCANNER) || !defined(YY_USER_ACTION)

/* For parsers that do not define yyrestart() */
/* Define it as a function so we get an error if it is already defined */
void
yyrestart(fp)
FILE *fp;
{
    yyin = fp;
}
#else	/* !defined(FLEX_SCANNER) || !defined(YY_USER_ACTION) */

/* Assign yyin the first time and call yyrestart() other times */
#define	YYRESTART_MAGIC

#endif	/* !defined(FLEX_SCANNER) || !defined(YY_USER_ACTION) */


/*
 *	Open the first file (called from parse_parse).  If no file specified,
 *	assume stdin (for testing ).
 */
int
parse_open(name)
char *name;
{
#ifdef	YYRESTART_MAGIC
    static int first;
#endif	/* YYRESTART_MAGIC */
    struct fi_info *fip;
    FILE *file;

    fip = &parse_fi[fi_file = 0];

    if (name) {
	file = fopen(name, "r");
	if (!file) {
	    trace_log_tf(trace_global,
			 0,
			 LOG_ERR,
			 ("parse_open: error opening %s: %m",
			  name));
	    return TRUE;
	}
    } else {
#if	YYDEBUG != 0
	name = "stdin";
#else	/* YYDEBUG */
	trace_log_tf(trace_global,
		     0,
		     LOG_ERR,
		     ("parse_open: no file specified"));
	return TRUE;
#endif	/* YYDEBUG */
    }

    yylineno = 1;
#ifdef	YYRESTART_MAGIC
    if (first++) {
	yyrestart(file);
    } else {
	yyin = file;
    }
#else	/* YYRESTART_MAGIC */
    yyrestart(file);
#endif	/* YYRESTART_MAGIC */

    fip->fi_name = name;
    parse_newname(fip);
    trace_tf(trace_global,
	     TR_PARSE,
	     0,
	     ("parse_open: reading %s (%d)",
	      fip->fi_name,
	      fileno(file)));
	
    YBEGIN(CONFIG);
    return FALSE;
}


/*
 *	Process an include directive, read another input file
 */
static int
parse_include __PF1(name, char *)
{
    struct fi_info *fip;
    FILE *file;

    /* Verify file name is unique (this is easy to fool) */
    for (fip = parse_fi; fip <= &parse_fi[fi_file]; fip++) {
	if (fip->fi_name && !strcmp(name, fip->fi_name)) {
	    (void) sprintf(parse_error, "recursive includes: %s",
			   name);
	    return TRUE;
	}
    }

    /* Try to open new file */
    if (fi_file > FI_MAX) {
	(void) sprintf(parse_error, "too many levels of includes");
	return TRUE;
    }

    file = fopen(name, "r");
    if (!file) {
	(void) sprintf(parse_error, "error opening %s: %m",
		       name);
	return TRUE;
    }

    /* Update line number of current file and make sure we have correct file pointer */
    fip = &parse_fi[fi_file++];
    SAVE_YY_STATE(fip);
    fip->fi_lineno = yylineno;

    fip++;
    fip->fi_name = name;
    yylineno = 1;
    yyin = file;
    NEW_YY_FILE(fip, file);
    parse_newname(fip);
    trace_tf(trace_global,
	     TR_PARSE,
	     0,
	     ("parse_include: %s now reading %s (%d)",
	      parse_where(),
	      fip->fi_name,
	      fileno(file)));

    return FALSE;
}


/* parse_eof - process end of file on current input file */
static int
parse_eof()
{
    struct fi_info *fip;

    if (fi_file < 0) {
	return TRUE;
    }
    
    fip = &parse_fi[fi_file];
    trace_tf(trace_global,
	     TR_PARSE,
	     0,
	     ("parse_eof: %s EOF on %s (%d)",
	      parse_where(),
	      fip->fi_name,
	      fileno(yyin)));
    if (fclose(yyin)) {
	trace_log_tf(trace_global,
		     0,
		     LOG_ERR,
		     ("parse_eof: error closing %s: %m",
		      fip->fi_name));
    }
    task_mem_free((task *) 0, fip->fi_name);
    fip->fi_name = NULL;
    parse_filename = NULL;
    DELETE_YY_STATE(fip);

    if (fi_file-- > 0) {
	fip = &parse_fi[fi_file];
	parse_newname(fip);
	yylineno = fip->fi_lineno;
	SET_YY_STATE(fip);
	trace_tf(trace_global,
		 TR_PARSE,
		 0,
		 ("parse_eof: %s resuming %s (%d)",
		  parse_where(),
		  fip->fi_name,
		  fileno(yyin)));
	return FALSE;
    }
    yyin = (FILE *) 0;
    trace_tf(trace_global,
	     TR_PARSE,
	     0,
	     ("parse_eof: %s EOF",
	      parse_where()));
    return TRUE;
}


/*
 * ------------------------------------------------------------------------
 * 
 * 	GateD, Release 3
 * 
 * 	Copyright (c) 1990,1991,1992,1993 by Cornell University
 * 	    All rights reserved.
 * 
 * 	THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY
 * 	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
 * 	LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * 	AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * 	Royalty-free licenses to redistribute GateD Release
 * 	3 in whole or in part may be obtained by writing to:
 * 
 * 	    GateDaemon Project
 * 	    Information Technologies/Network Resources
 * 	    200 CCC
 * 	    Cornell University
 * 	    Ithaca, NY  14853-2601  USA
 * 
 * 	GateD is based on Kirton's EGP, UC Berkeley's routing
 * 	daemon	 (routed), and DCN's HELLO routing Protocol.
 * 	Development of GateD has been supported in part by the
 * 	National Science Foundation.
 * 
 * 	Please forward bug fixes, enhancements and questions to the
 * 	gated mailing list: gated-people@gated.cornell.edu.
 * 
 * 	Authors:
 * 
 * 		Jeffrey C Honig <jch@gated.cornell.edu>
 * 		Scott W Brim <swb@gated.cornell.edu>
 * 
 * ------------------------------------------------------------------------
 * 
 *       Portions of this software may fall under the following
 *       copyrights:
 * 
 * 	Copyright (c) 1988 Regents of the University of California.
 * 	All rights reserved.
 * 
 * 	Redistribution and use in source and binary forms are
 * 	permitted provided that the above copyright notice and
 * 	this paragraph are duplicated in all such forms and that
 * 	any documentation, advertising materials, and other
 * 	materials related to such distribution and use
 * 	acknowledge that the software was developed by the
 * 	University of California, Berkeley.  The name of the
 * 	University may not be used to endorse or promote
 * 	products derived from this software without specific
 * 	prior written permission.  THIS SOFTWARE IS PROVIDED
 * 	``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
 * 	INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * 	MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
int yyvstop[] = {
0,

21,
0,

3,
21,
0,

21,
0,

1,
21,
0,

21,
0,

21,
0,

6,
21,
0,

8,
0,

14,
21,
0,

14,
21,
0,

15,
21,
0,

15,
21,
0,

15,
21,
0,

15,
21,
0,

9,
21,
0,

6,
13,
21,
0,

6,
13,
21,
0,

12,
21,
0,

7,
0,

3,
0,

5,
0,

1,
0,

2,
0,

4,
0,

6,
0,

16,
0,

15,
0,

15,
0,

15,
0,

15,
0,

13,
0,

6,
13,
0,

6,
13,
0,

18,
0,

18,
0,

18,
0,

15,
0,

15,
0,

13,
0,

13,
0,

6,
13,
0,

16,
0,

18,
0,

18,
0,

18,
0,

18,
0,

18,
0,

18,
0,

20,
0,

6,
13,
0,

13,
0,

19,
0,

18,
0,

18,
0,

18,
0,

18,
0,

6,
13,
19,
0,

13,
0,

16,
0,

18,
0,

13,
0,

13,
0,

16,
0,

18,
0,

18,
0,

18,
0,

13,
0,

18,
0,

18,
0,

18,
0,

18,
0,

13,
0,

16,
0,

18,
0,

13,
0,

13,
0,

10,
0,

16,
0,

18,
0,

18,
0,

18,
0,

13,
0,

18,
0,

18,
0,

18,
0,

18,
0,

13,
0,

11,
0,

18,
0,

13,
0,

13,
0,

17,
18,
0,

17,
18,
0,

17,
18,
0,

17,
0,

13,
17,
0,

13,
0,

17,
18,
0,

17,
18,
0,

17,
18,
0,

17,
0,

13,
17,
0,

17,
18,
0,

17,
18,
0,

17,
18,
0,
0};
# define YYTYPE int
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,7,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,8,	1,0,	
0,0,	29,0,	8,26,	2,0,	
127,127,	127,133,	0,0,	0,0,	
112,112,	5,25,	0,0,	0,0,	
140,140,	140,147,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	24,47,	0,0,	1,9,	
1,10,	8,26,	0,0,	127,127,	
2,10,	1,7,	0,0,	112,112,	
11,30,	112,121,	5,10,	140,140,	
1,11,	1,7,	35,50,	1,7,	
2,11,	46,44,	1,7,	1,7,	
24,47,	6,25,	5,11,	67,82,	
70,36,	1,12,	83,54,	1,7,	
88,36,	2,12,	1,13,	3,7,	
1,13,	1,13,	1,13,	5,12,	
1,13,	93,99,	1,13,	3,8,	
3,14,	1,13,	48,65,	1,13,	
1,13,	94,100,	6,10,	1,13,	
95,101,	1,13,	1,13,	105,113,	
118,36,	1,13,	1,13,	49,66,	
24,48,	122,128,	6,11,	65,80,	
123,129,	24,49,	66,81,	124,130,	
3,9,	3,10,	41,60,	41,60,	
41,60,	41,60,	3,15,	6,12,	
80,91,	81,92,	48,65,	91,97,	
3,16,	3,11,	3,17,	3,18,	
3,19,	3,20,	3,20,	3,20,	
3,20,	92,98,	145,36,	49,66,	
24,48,	3,21,	3,12,	65,80,	
3,7,	24,49,	66,81,	3,22,	
148,151,	3,22,	3,22,	3,22,	
97,103,	3,23,	98,104,	3,23,	
80,91,	81,92,	3,23,	91,97,	
3,23,	3,23,	149,152,	4,10,	
3,23,	4,24,	3,23,	3,23,	
103,111,	92,98,	3,23,	3,23,	
104,112,	9,27,	4,16,	4,11,	
111,120,	4,18,	120,126,	4,20,	
4,20,	9,27,	9,27,	155,159,	
97,103,	157,160,	98,104,	4,21,	
4,12,	16,35,	16,35,	16,35,	
16,35,	16,35,	16,35,	16,35,	
16,35,	16,35,	16,35,	51,36,	
103,111,	51,53,	51,53,	51,53,	
104,112,	0,0,	9,28,	126,126,	
111,120,	0,0,	120,126,	0,0,	
9,27,	53,70,	53,70,	53,70,	
53,70,	53,70,	53,70,	10,29,	
9,27,	0,0,	9,27,	0,0,	
0,0,	9,27,	9,27,	10,29,	
10,0,	0,0,	126,126,	0,0,	
126,132,	0,0,	9,27,	0,0,	
0,0,	9,27,	0,0,	9,27,	
9,27,	9,27,	0,0,	9,27,	
0,0,	9,27,	0,0,	0,0,	
9,27,	0,0,	9,27,	9,27,	
10,29,	0,0,	9,27,	0,0,	
9,27,	9,27,	10,29,	0,0,	
9,27,	9,27,	0,0,	0,0,	
0,0,	12,31,	10,29,	0,0,	
10,29,	0,0,	0,0,	10,29,	
10,29,	12,31,	12,31,	154,159,	
0,0,	154,53,	154,53,	154,53,	
10,29,	0,0,	0,0,	10,29,	
0,0,	10,29,	10,29,	10,29,	
0,0,	10,29,	0,0,	10,29,	
0,0,	0,0,	10,29,	0,0,	
10,29,	10,29,	12,31,	0,0,	
10,29,	0,0,	10,29,	10,29,	
12,31,	0,0,	10,29,	10,29,	
0,0,	0,0,	0,0,	0,0,	
12,31,	0,0,	12,31,	0,0,	
0,0,	12,31,	12,31,	68,70,	
68,70,	68,70,	68,70,	68,70,	
68,70,	0,0,	12,32,	0,0,	
0,0,	12,31,	0,0,	12,31,	
12,31,	12,31,	0,0,	12,31,	
0,0,	12,31,	0,0,	0,0,	
12,31,	0,0,	12,31,	12,31,	
0,0,	0,0,	12,31,	0,0,	
12,31,	12,31,	0,0,	13,33,	
12,31,	12,31,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
162,159,	0,0,	162,164,	162,164,	
162,164,	0,0,	0,0,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	13,34,	13,34,	13,34,	
13,34,	17,36,	0,0,	17,37,	
17,37,	17,37,	17,37,	17,37,	
17,37,	17,37,	17,37,	17,37,	
17,37,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
17,38,	17,38,	17,38,	17,38,	
17,38,	17,38,	18,36,	0,0,	
18,37,	18,37,	18,37,	18,37,	
18,37,	18,37,	18,37,	18,37,	
18,37,	18,37,	0,0,	0,0,	
0,0,	0,0,	0,0,	17,39,	
0,0,	18,38,	18,38,	18,38,	
18,38,	18,38,	18,38,	0,0,	
17,38,	17,38,	17,38,	17,38,	
17,38,	17,38,	19,40,	19,40,	
19,40,	19,40,	19,40,	19,41,	
19,42,	19,42,	19,42,	19,42,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	17,39,	
0,0,	18,38,	18,38,	18,38,	
18,38,	18,38,	18,38,	20,42,	
20,42,	20,42,	20,42,	20,42,	
20,42,	20,42,	20,42,	20,42,	
20,42,	22,43,	22,44,	0,0,	
22,45,	22,45,	22,45,	22,45,	
22,45,	22,45,	22,45,	22,45,	
22,45,	22,45,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	22,45,	22,45,	22,45,	
22,45,	22,45,	22,45,	22,46,	
22,46,	22,46,	22,46,	22,46,	
22,46,	22,46,	22,46,	22,46,	
22,46,	22,46,	22,46,	22,46,	
22,46,	22,46,	22,46,	22,46,	
22,46,	22,46,	22,46,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	22,45,	22,45,	22,45,	
22,45,	22,45,	22,45,	22,46,	
22,46,	22,46,	22,46,	22,46,	
22,46,	22,46,	22,46,	22,46,	
22,46,	22,46,	22,46,	22,46,	
22,46,	22,46,	22,46,	22,46,	
22,46,	22,46,	22,46,	23,46,	
23,46,	23,46,	23,46,	23,46,	
23,46,	23,46,	23,46,	23,46,	
23,46,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
23,46,	23,46,	23,46,	23,46,	
23,46,	23,46,	36,51,	36,51,	
36,52,	36,53,	36,53,	36,53,	
36,53,	36,53,	36,53,	36,53,	
0,0,	0,0,	37,54,	37,55,	
0,0,	37,56,	37,56,	37,56,	
37,56,	37,56,	37,56,	37,56,	
37,56,	37,56,	37,56,	0,0,	
23,46,	23,46,	23,46,	23,46,	
23,46,	23,46,	37,57,	37,57,	
37,57,	37,57,	37,57,	37,57,	
38,58,	0,0,	38,57,	38,57,	
38,57,	38,57,	38,57,	38,57,	
38,57,	38,57,	38,57,	38,57,	
0,0,	0,0,	0,0,	39,59,	
39,59,	39,59,	39,59,	39,59,	
39,59,	39,59,	39,59,	39,59,	
39,59,	0,0,	37,57,	37,57,	
37,57,	37,57,	37,57,	37,57,	
39,59,	39,59,	39,59,	39,59,	
39,59,	39,59,	42,60,	42,60,	
42,60,	42,60,	42,60,	42,60,	
42,60,	42,60,	42,60,	42,60,	
0,0,	0,0,	43,43,	0,0,	
0,0,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	0,0,	
39,59,	39,59,	39,59,	39,59,	
39,59,	39,59,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
43,46,	43,46,	43,46,	43,46,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	44,61,	44,61,	
44,61,	44,61,	45,62,	45,63,	
0,0,	45,64,	45,64,	45,64,	
45,64,	45,64,	45,64,	45,64,	
45,64,	45,64,	45,64,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	45,64,	45,64,	
45,64,	45,64,	45,64,	45,64,	
50,67,	50,67,	50,67,	50,67,	
50,67,	50,67,	50,67,	50,67,	
50,67,	50,67,	52,36,	0,0,	
52,68,	52,68,	52,68,	52,68,	
52,68,	52,69,	52,70,	52,70,	
52,70,	52,70,	0,0,	0,0,	
0,0,	0,0,	45,64,	45,64,	
45,64,	45,64,	45,64,	45,64,	
54,71,	54,71,	54,71,	54,71,	
54,71,	54,71,	54,71,	54,71,	
54,71,	54,71,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	54,71,	54,71,	54,71,	
54,71,	54,71,	54,71,	55,72,	
55,72,	55,73,	55,74,	55,74,	
55,74,	55,74,	55,74,	55,74,	
55,74,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
55,75,	55,75,	55,75,	55,75,	
55,75,	55,75,	0,0,	0,0,	
0,0,	54,71,	54,71,	54,71,	
54,71,	54,71,	54,71,	56,36,	
0,0,	56,60,	56,60,	56,60,	
56,60,	56,60,	56,60,	56,60,	
56,60,	56,60,	56,60,	0,0,	
0,0,	0,0,	0,0,	0,0,	
55,75,	55,75,	55,75,	55,75,	
55,75,	55,75,	57,54,	0,0,	
0,0,	57,57,	57,57,	57,57,	
57,57,	57,57,	57,57,	57,57,	
57,57,	57,57,	57,57,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	57,57,	57,57,	
57,57,	57,57,	57,57,	57,57,	
58,75,	58,75,	58,75,	58,75,	
58,75,	58,75,	58,75,	58,75,	
58,75,	58,75,	0,0,	0,0,	
0,0,	0,0,	0,0,	59,76,	
59,76,	59,76,	59,76,	59,76,	
59,76,	59,76,	59,76,	59,76,	
59,76,	0,0,	57,57,	57,57,	
57,57,	57,57,	57,57,	57,57,	
59,76,	59,76,	59,76,	59,76,	
59,76,	59,76,	60,60,	60,60,	
60,60,	60,60,	60,60,	60,60,	
60,60,	60,60,	60,60,	60,60,	
61,77,	61,44,	0,0,	61,61,	
61,61,	61,61,	61,61,	61,61,	
61,61,	61,61,	61,61,	61,61,	
61,61,	0,0,	0,0,	0,0,	
59,76,	59,76,	59,76,	59,76,	
59,76,	59,76,	62,78,	62,78,	
62,78,	62,78,	62,78,	62,78,	
62,78,	62,78,	62,78,	62,78,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	62,78,	
62,78,	62,78,	62,78,	62,78,	
62,78,	63,75,	63,75,	63,75,	
63,75,	63,75,	63,75,	63,75,	
63,75,	63,75,	63,75,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	63,79,	63,79,	
63,79,	63,79,	63,79,	63,79,	
0,0,	0,0,	0,0,	62,78,	
62,78,	62,78,	62,78,	62,78,	
62,78,	0,0,	0,0,	0,0,	
64,62,	0,0,	0,0,	64,64,	
64,64,	64,64,	64,64,	64,64,	
64,64,	64,64,	64,64,	64,64,	
64,64,	0,0,	63,79,	63,79,	
63,79,	63,79,	63,79,	63,79,	
64,64,	64,64,	64,64,	64,64,	
64,64,	64,64,	69,36,	156,159,	
69,70,	69,70,	69,70,	69,70,	
69,70,	69,70,	0,0,	156,70,	
156,70,	156,70,	156,70,	0,0,	
0,0,	71,83,	71,83,	71,83,	
71,83,	71,83,	71,83,	71,83,	
71,83,	71,83,	71,83,	0,0,	
64,64,	64,64,	64,64,	64,64,	
64,64,	64,64,	71,83,	71,83,	
71,83,	71,83,	71,83,	71,83,	
72,84,	72,84,	72,84,	72,84,	
72,84,	72,84,	72,84,	72,84,	
72,84,	72,84,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	72,85,	72,85,	72,85,	
72,85,	72,85,	72,85,	0,0,	
0,0,	0,0,	71,83,	71,83,	
71,83,	71,83,	71,83,	71,83,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	73,86,	73,86,	
73,86,	73,86,	73,86,	73,87,	
73,88,	73,88,	73,88,	73,88,	
0,0,	72,85,	72,85,	72,85,	
72,85,	72,85,	72,85,	73,85,	
73,85,	73,85,	73,85,	73,85,	
73,85,	74,88,	74,88,	74,88,	
74,88,	74,88,	74,88,	74,88,	
74,88,	74,88,	74,88,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	74,85,	74,85,	
74,85,	74,85,	74,85,	74,85,	
0,0,	0,0,	0,0,	73,85,	
73,85,	73,85,	73,85,	73,85,	
73,85,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	75,85,	
75,85,	75,85,	75,85,	75,85,	
75,85,	75,85,	75,85,	75,85,	
75,85,	0,0,	74,85,	74,85,	
74,85,	74,85,	74,85,	74,85,	
75,85,	75,85,	75,85,	75,85,	
75,85,	75,85,	77,77,	0,0,	
0,0,	77,61,	77,61,	77,61,	
77,61,	77,61,	77,61,	77,61,	
77,61,	77,61,	77,61,	0,0,	
0,0,	78,89,	78,89,	78,89,	
78,89,	78,89,	78,89,	78,89,	
78,89,	78,89,	78,89,	0,0,	
75,85,	75,85,	75,85,	75,85,	
75,85,	75,85,	78,89,	78,89,	
78,89,	78,89,	78,89,	78,89,	
79,77,	79,44,	0,0,	79,90,	
79,90,	79,90,	79,90,	79,90,	
79,90,	79,90,	79,90,	79,90,	
79,90,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
79,90,	79,90,	79,90,	79,90,	
79,90,	79,90,	78,89,	78,89,	
78,89,	78,89,	78,89,	78,89,	
82,93,	82,93,	82,93,	82,93,	
82,93,	82,93,	82,93,	82,93,	
82,93,	82,93,	84,94,	84,94,	
84,94,	84,94,	84,94,	84,94,	
84,94,	84,94,	84,94,	84,94,	
79,90,	79,90,	79,90,	79,90,	
79,90,	79,90,	0,0,	84,95,	
84,95,	84,95,	84,95,	84,95,	
84,95,	85,95,	85,95,	85,95,	
85,95,	85,95,	85,95,	85,95,	
85,95,	85,95,	85,95,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	85,95,	85,95,	
85,95,	85,95,	85,95,	85,95,	
0,0,	0,0,	0,0,	84,95,	
84,95,	84,95,	84,95,	84,95,	
84,95,	86,36,	0,0,	86,94,	
86,94,	86,94,	86,94,	86,94,	
86,94,	86,94,	86,94,	86,94,	
86,94,	0,0,	0,0,	0,0,	
0,0,	0,0,	85,95,	85,95,	
85,95,	85,95,	85,95,	85,95,	
87,36,	0,0,	87,94,	87,94,	
87,94,	87,94,	87,94,	87,94,	
89,62,	0,0,	0,0,	89,89,	
89,89,	89,89,	89,89,	89,89,	
89,89,	89,89,	89,89,	89,89,	
89,89,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
89,89,	89,89,	89,89,	89,89,	
89,89,	89,89,	90,77,	90,44,	
0,0,	90,96,	90,96,	90,96,	
90,96,	90,96,	90,96,	90,96,	
90,96,	90,96,	90,96,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	90,96,	90,96,	
90,96,	90,96,	90,96,	90,96,	
89,89,	89,89,	89,89,	89,89,	
89,89,	89,89,	96,77,	96,102,	
0,0,	96,61,	96,61,	96,61,	
96,61,	96,61,	96,61,	96,61,	
96,61,	96,61,	96,61,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	90,96,	90,96,	
90,96,	90,96,	90,96,	90,96,	
99,105,	99,105,	99,105,	99,105,	
99,105,	99,105,	99,105,	99,105,	
99,105,	99,105,	100,106,	100,106,	
100,107,	100,108,	100,108,	100,108,	
100,108,	100,108,	100,108,	100,108,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	100,109,	
100,109,	100,109,	100,109,	100,109,	
100,109,	101,109,	101,109,	101,109,	
101,109,	101,109,	101,109,	101,109,	
101,109,	101,109,	101,109,	0,0,	
0,0,	0,0,	0,0,	0,0,	
102,109,	102,109,	102,109,	102,109,	
102,109,	102,109,	102,109,	102,109,	
102,109,	102,109,	0,0,	100,109,	
100,109,	100,109,	100,109,	100,109,	
100,109,	102,110,	102,110,	102,110,	
102,110,	102,110,	102,110,	106,114,	
106,114,	106,114,	106,114,	106,114,	
106,114,	106,114,	106,114,	106,114,	
106,114,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
106,115,	106,115,	106,115,	106,115,	
106,115,	106,115,	0,0,	0,0,	
0,0,	102,110,	102,110,	102,110,	
102,110,	102,110,	102,110,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	107,116,	107,116,	107,116,	
107,116,	107,116,	107,117,	107,118,	
107,118,	107,118,	107,118,	0,0,	
106,115,	106,115,	106,115,	106,115,	
106,115,	106,115,	107,115,	107,115,	
107,115,	107,115,	107,115,	107,115,	
108,118,	108,118,	108,118,	108,118,	
108,118,	108,118,	108,118,	108,118,	
108,118,	108,118,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	108,115,	108,115,	108,115,	
108,115,	108,115,	108,115,	0,0,	
0,0,	0,0,	107,115,	107,115,	
107,115,	107,115,	107,115,	107,115,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	109,115,	109,115,	
109,115,	109,115,	109,115,	109,115,	
109,115,	109,115,	109,115,	109,115,	
0,0,	108,115,	108,115,	108,115,	
108,115,	108,115,	108,115,	109,115,	
109,115,	109,115,	109,115,	109,115,	
109,115,	110,77,	110,44,	0,0,	
110,119,	110,119,	110,119,	110,119,	
110,119,	110,119,	110,119,	110,119,	
110,119,	110,119,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	110,119,	110,119,	110,119,	
110,119,	110,119,	110,119,	109,115,	
109,115,	109,115,	109,115,	109,115,	
109,115,	113,122,	113,122,	113,122,	
113,122,	113,122,	113,122,	113,122,	
113,122,	113,122,	113,122,	114,123,	
114,123,	114,123,	114,123,	114,123,	
114,123,	114,123,	114,123,	114,123,	
114,123,	110,119,	110,119,	110,119,	
110,119,	110,119,	110,119,	0,0,	
114,124,	114,124,	114,124,	114,124,	
114,124,	114,124,	115,124,	115,124,	
115,124,	115,124,	115,124,	115,124,	
115,124,	115,124,	115,124,	115,124,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	115,124,	
115,124,	115,124,	115,124,	115,124,	
115,124,	0,0,	0,0,	0,0,	
114,124,	114,124,	114,124,	114,124,	
114,124,	114,124,	116,36,	0,0,	
116,123,	116,123,	116,123,	116,123,	
116,123,	116,123,	116,123,	116,123,	
116,123,	116,123,	0,0,	0,0,	
0,0,	0,0,	0,0,	115,124,	
115,124,	115,124,	115,124,	115,124,	
115,124,	117,36,	0,0,	117,123,	
117,123,	117,123,	117,123,	117,123,	
117,123,	119,77,	119,44,	0,0,	
119,125,	119,125,	119,125,	119,125,	
119,125,	119,125,	119,125,	119,125,	
119,125,	119,125,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	119,125,	119,125,	119,125,	
119,125,	119,125,	119,125,	121,121,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	121,121,	
121,121,	125,77,	125,131,	0,0,	
125,61,	125,61,	125,61,	125,61,	
125,61,	125,61,	125,61,	125,61,	
125,61,	125,61,	0,0,	0,0,	
0,0,	119,125,	119,125,	119,125,	
119,125,	119,125,	119,125,	0,0,	
121,127,	0,0,	0,0,	0,0,	
0,0,	144,36,	121,121,	144,148,	
144,148,	144,148,	144,148,	144,148,	
144,148,	0,0,	121,121,	0,0,	
121,121,	0,0,	0,0,	121,121,	
121,121,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
121,121,	0,0,	0,0,	121,121,	
0,0,	121,121,	121,121,	121,121,	
0,0,	121,121,	0,0,	121,121,	
0,0,	0,0,	121,121,	0,0,	
121,121,	121,121,	0,0,	0,0,	
121,121,	0,0,	121,121,	121,121,	
0,0,	0,0,	121,121,	121,121,	
128,134,	128,134,	128,134,	128,134,	
128,134,	128,134,	128,134,	128,134,	
128,134,	128,134,	129,135,	129,135,	
129,136,	129,137,	129,137,	129,137,	
129,137,	129,137,	129,137,	129,137,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	129,138,	
129,138,	129,138,	129,138,	129,138,	
129,138,	130,138,	130,138,	130,138,	
130,138,	130,138,	130,138,	130,138,	
130,138,	130,138,	130,138,	0,0,	
0,0,	0,0,	0,0,	0,0,	
131,138,	131,138,	131,138,	131,138,	
131,138,	131,138,	131,138,	131,138,	
131,138,	131,138,	0,0,	129,138,	
129,138,	129,138,	129,138,	129,138,	
129,138,	131,139,	131,139,	131,139,	
131,139,	131,139,	131,139,	132,132,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	132,132,	
132,132,	143,36,	0,0,	143,148,	
143,148,	143,148,	143,148,	143,148,	
143,148,	143,148,	143,148,	143,148,	
143,148,	0,0,	0,0,	0,0,	
0,0,	131,139,	131,139,	131,139,	
131,139,	131,139,	131,139,	0,0,	
132,140,	0,0,	0,0,	0,0,	
0,0,	0,0,	132,132,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	132,132,	0,0,	
132,132,	0,0,	0,0,	132,132,	
132,132,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
132,132,	0,0,	0,0,	132,132,	
0,0,	132,132,	132,132,	132,132,	
0,0,	132,132,	0,0,	132,132,	
0,0,	0,0,	132,132,	0,0,	
132,132,	132,132,	0,0,	0,0,	
132,132,	0,0,	132,132,	132,132,	
0,0,	0,0,	132,132,	132,132,	
135,141,	135,141,	135,141,	135,141,	
135,141,	135,141,	135,141,	135,141,	
135,141,	135,141,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	135,142,	135,142,	135,142,	
135,142,	135,142,	135,142,	136,143,	
136,143,	136,143,	136,143,	136,143,	
136,144,	136,145,	136,145,	136,145,	
136,145,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
136,142,	136,142,	136,142,	136,142,	
136,142,	136,142,	0,0,	0,0,	
0,0,	135,142,	135,142,	135,142,	
135,142,	135,142,	135,142,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	137,145,	137,145,	137,145,	
137,145,	137,145,	137,145,	137,145,	
137,145,	137,145,	137,145,	0,0,	
136,142,	136,142,	136,142,	136,142,	
136,142,	136,142,	137,142,	137,142,	
137,142,	137,142,	137,142,	137,142,	
138,142,	138,142,	138,142,	138,142,	
138,142,	138,142,	138,142,	138,142,	
138,142,	138,142,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	138,142,	138,142,	138,142,	
138,142,	138,142,	138,142,	0,0,	
0,0,	0,0,	137,142,	137,142,	
137,142,	137,142,	137,142,	137,142,	
0,0,	0,0,	0,0,	139,77,	
139,44,	0,0,	139,146,	139,146,	
139,146,	139,146,	139,146,	139,146,	
139,146,	139,146,	139,146,	139,146,	
0,0,	138,142,	138,142,	138,142,	
138,142,	138,142,	138,142,	139,146,	
139,146,	139,146,	139,146,	139,146,	
139,146,	141,148,	141,148,	141,148,	
141,148,	141,148,	141,148,	141,148,	
141,148,	141,148,	141,148,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	141,149,	141,149,	
141,149,	141,149,	141,149,	141,149,	
0,0,	0,0,	0,0,	139,146,	
139,146,	139,146,	139,146,	139,146,	
139,146,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	142,149,	
142,149,	142,149,	142,149,	142,149,	
142,149,	142,149,	142,149,	142,149,	
142,149,	0,0,	141,149,	141,149,	
141,149,	141,149,	141,149,	141,149,	
142,149,	142,149,	142,149,	142,149,	
142,149,	142,149,	146,77,	146,44,	
0,0,	146,150,	146,150,	146,150,	
146,150,	146,150,	146,150,	146,150,	
146,150,	146,150,	146,150,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	146,150,	146,150,	
146,150,	146,150,	146,150,	146,150,	
142,149,	142,149,	142,149,	142,149,	
142,149,	142,149,	150,77,	150,153,	
0,0,	150,61,	150,61,	150,61,	
150,61,	150,61,	150,61,	150,61,	
150,61,	150,61,	150,61,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	146,150,	146,150,	
146,150,	146,150,	146,150,	146,150,	
151,154,	151,154,	151,155,	151,156,	
151,156,	151,156,	151,156,	151,156,	
151,156,	151,156,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	151,157,	151,157,	151,157,	
151,157,	151,157,	151,157,	152,157,	
152,157,	152,157,	152,157,	152,157,	
152,157,	152,157,	152,157,	152,157,	
152,157,	0,0,	0,0,	0,0,	
0,0,	0,0,	153,157,	153,157,	
153,157,	153,157,	153,157,	153,157,	
153,157,	153,157,	153,157,	153,157,	
0,0,	151,157,	151,157,	151,157,	
151,157,	151,157,	151,157,	153,158,	
153,158,	153,158,	153,158,	153,158,	
153,158,	158,77,	158,161,	0,0,	
158,61,	158,61,	158,61,	158,61,	
158,61,	158,61,	158,61,	158,61,	
158,61,	158,61,	0,0,	0,0,	
159,162,	159,162,	159,163,	159,164,	
159,164,	159,164,	159,164,	159,164,	
159,164,	159,164,	0,0,	153,158,	
153,158,	153,158,	153,158,	153,158,	
153,158,	159,165,	159,165,	159,165,	
159,165,	159,165,	159,165,	160,165,	
160,165,	160,165,	160,165,	160,165,	
160,165,	160,165,	160,165,	160,165,	
160,165,	0,0,	0,0,	0,0,	
0,0,	0,0,	161,165,	161,165,	
161,165,	161,165,	161,165,	161,165,	
161,165,	161,165,	161,165,	161,165,	
0,0,	159,165,	159,165,	159,165,	
159,165,	159,165,	159,165,	161,166,	
161,166,	161,166,	161,166,	161,166,	
161,166,	163,159,	0,0,	163,167,	
163,167,	163,167,	163,167,	163,167,	
163,168,	163,169,	163,169,	163,169,	
163,169,	164,159,	0,0,	164,169,	
164,169,	164,169,	164,169,	164,169,	
164,169,	164,169,	164,169,	164,169,	
164,169,	0,0,	0,0,	161,166,	
161,166,	161,166,	161,166,	161,166,	
161,166,	165,160,	0,0,	165,165,	
165,165,	165,165,	165,165,	165,165,	
165,165,	165,165,	165,165,	165,165,	
165,165,	166,77,	166,161,	0,0,	
166,166,	166,166,	166,166,	166,166,	
166,166,	166,166,	166,166,	166,166,	
166,166,	166,166,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	166,166,	166,166,	166,166,	
166,166,	166,166,	166,166,	167,159,	
0,0,	167,169,	167,169,	167,169,	
167,169,	167,169,	167,169,	167,169,	
167,169,	167,169,	167,169,	168,159,	
0,0,	168,169,	168,169,	168,169,	
168,169,	168,169,	168,169,	168,165,	
168,165,	168,165,	168,165,	0,0,	
0,0,	166,166,	166,166,	166,166,	
166,166,	166,166,	166,166,	169,159,	
0,0,	169,165,	169,165,	169,165,	
169,165,	169,165,	169,165,	169,165,	
169,165,	169,165,	169,165,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-5,	yysvec+1,	0,	
yycrank+-66,	0,		0,	
yycrank+-112,	yysvec+3,	0,	
yycrank+-11,	yysvec+1,	0,	
yycrank+-47,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+5,	0,		yyvstop+3,
yycrank+-156,	0,		yyvstop+6,
yycrank+-202,	0,		yyvstop+8,
yycrank+2,	0,		yyvstop+11,
yycrank+-248,	0,		yyvstop+13,
yycrank+290,	0,		yyvstop+15,
yycrank+0,	0,		yyvstop+18,
yycrank+0,	0,		yyvstop+20,
yycrank+125,	0,		yyvstop+23,
yycrank+367,	0,		yyvstop+26,
yycrank+392,	0,		yyvstop+29,
yycrank+422,	yysvec+18,	yyvstop+32,
yycrank+447,	yysvec+18,	yyvstop+35,
yycrank+0,	0,		yyvstop+38,
yycrank+460,	0,		yyvstop+41,
yycrank+535,	yysvec+22,	yyvstop+45,
yycrank+24,	0,		yyvstop+49,
yycrank+0,	0,		yyvstop+52,
yycrank+0,	yysvec+8,	yyvstop+54,
yycrank+0,	yysvec+9,	0,	
yycrank+0,	0,		yyvstop+56,
yycrank+-3,	yysvec+10,	yyvstop+58,
yycrank+0,	0,		yyvstop+60,
yycrank+0,	yysvec+12,	0,	
yycrank+0,	0,		yyvstop+62,
yycrank+0,	yysvec+13,	0,	
yycrank+0,	yysvec+13,	yyvstop+64,
yycrank+4,	0,		yyvstop+66,
yycrank+558,	0,		0,	
yycrank+573,	0,		yyvstop+68,
yycrank+598,	yysvec+37,	0,	
yycrank+611,	0,		0,	
yycrank+0,	yysvec+37,	yyvstop+70,
yycrank+48,	yysvec+37,	yyvstop+72,
yycrank+634,	yysvec+37,	yyvstop+74,
yycrank+649,	0,		0,	
yycrank+707,	0,		yyvstop+76,
yycrank+785,	yysvec+22,	yyvstop+78,
yycrank+7,	yysvec+43,	yyvstop+81,
yycrank+0,	yysvec+24,	0,	
yycrank+5,	0,		0,	
yycrank+13,	0,		0,	
yycrank+808,	0,		0,	
yycrank+137,	yysvec+36,	yyvstop+84,
yycrank+820,	0,		yyvstop+86,
yycrank+149,	yysvec+52,	yyvstop+88,
yycrank+840,	0,		0,	
yycrank+863,	0,		0,	
yycrank+897,	yysvec+37,	yyvstop+90,
yycrank+921,	0,		0,	
yycrank+944,	yysvec+55,	0,	
yycrank+959,	0,		0,	
yycrank+982,	yysvec+57,	yyvstop+92,
yycrank+995,	yysvec+44,	yyvstop+94,
yycrank+1014,	yysvec+43,	0,	
yycrank+1037,	yysvec+44,	yyvstop+96,
yycrank+1075,	yysvec+22,	yyvstop+98,
yycrank+13,	0,		0,	
yycrank+31,	0,		0,	
yycrank+13,	0,		yyvstop+101,
yycrank+255,	yysvec+52,	yyvstop+103,
yycrank+1100,	0,		yyvstop+105,
yycrank+14,	0,		yyvstop+107,
yycrank+1113,	0,		0,	
yycrank+1136,	yysvec+18,	yyvstop+109,
yycrank+1174,	yysvec+18,	yyvstop+111,
yycrank+1197,	yysvec+18,	yyvstop+113,
yycrank+1235,	0,		0,	
yycrank+0,	yysvec+59,	yyvstop+115,
yycrank+1261,	yysvec+44,	0,	
yycrank+1273,	yysvec+22,	yyvstop+117,
yycrank+1299,	yysvec+44,	yyvstop+120,
yycrank+39,	0,		0,	
yycrank+33,	0,		0,	
yycrank+1328,	0,		0,	
yycrank+17,	yysvec+71,	yyvstop+122,
yycrank+1338,	yysvec+18,	yyvstop+124,
yycrank+1361,	0,		0,	
yycrank+1395,	yysvec+85,	yyvstop+126,
yycrank+1418,	yysvec+85,	yyvstop+128,
yycrank+18,	yysvec+85,	yyvstop+130,
yycrank+1427,	yysvec+22,	yyvstop+132,
yycrank+1453,	yysvec+44,	yyvstop+136,
yycrank+44,	0,		0,	
yycrank+36,	0,		0,	
yycrank+27,	0,		yyvstop+138,
yycrank+35,	0,		yyvstop+140,
yycrank+38,	0,		0,	
yycrank+1485,	yysvec+44,	yyvstop+142,
yycrank+52,	0,		0,	
yycrank+70,	0,		0,	
yycrank+1508,	0,		0,	
yycrank+1518,	0,		0,	
yycrank+1541,	yysvec+100,	0,	
yycrank+1556,	yysvec+44,	yyvstop+144,
yycrank+73,	0,		0,	
yycrank+87,	0,		0,	
yycrank+41,	0,		yyvstop+146,
yycrank+1579,	yysvec+18,	yyvstop+148,
yycrank+1617,	yysvec+18,	yyvstop+150,
yycrank+1640,	yysvec+18,	yyvstop+152,
yycrank+1678,	0,		0,	
yycrank+1704,	yysvec+44,	yyvstop+154,
yycrank+78,	0,		0,	
yycrank+11,	0,		0,	
yycrank+1733,	0,		0,	
yycrank+1743,	yysvec+18,	yyvstop+156,
yycrank+1766,	0,		0,	
yycrank+1800,	yysvec+115,	yyvstop+158,
yycrank+1823,	yysvec+115,	yyvstop+160,
yycrank+42,	yysvec+115,	yyvstop+162,
yycrank+1832,	yysvec+44,	yyvstop+164,
yycrank+73,	0,		0,	
yycrank+-1902,	0,		0,	
yycrank+47,	0,		yyvstop+166,
yycrank+50,	0,		yyvstop+168,
yycrank+53,	0,		0,	
yycrank+1868,	yysvec+44,	yyvstop+170,
yycrank+182,	0,		0,	
yycrank+7,	0,		0,	
yycrank+1944,	0,		0,	
yycrank+1954,	0,		0,	
yycrank+1977,	yysvec+129,	0,	
yycrank+1992,	yysvec+44,	yyvstop+172,
yycrank+-2062,	0,		0,	
yycrank+0,	0,		yyvstop+174,
yycrank+0,	0,		yyvstop+176,
yycrank+2104,	yysvec+18,	yyvstop+178,
yycrank+2127,	yysvec+18,	yyvstop+180,
yycrank+2165,	yysvec+18,	yyvstop+182,
yycrank+2188,	0,		0,	
yycrank+2226,	yysvec+44,	yyvstop+184,
yycrank+15,	0,		0,	
yycrank+2249,	yysvec+18,	yyvstop+186,
yycrank+2287,	0,		0,	
yycrank+2027,	yysvec+142,	yyvstop+188,
yycrank+1895,	yysvec+142,	yyvstop+190,
yycrank+76,	yysvec+142,	yyvstop+192,
yycrank+2313,	yysvec+44,	yyvstop+194,
yycrank+0,	0,		yyvstop+196,
yycrank+86,	0,		yyvstop+198,
yycrank+100,	0,		0,	
yycrank+2345,	yysvec+44,	yyvstop+200,
yycrank+2368,	0,		0,	
yycrank+2391,	yysvec+151,	0,	
yycrank+2406,	yysvec+44,	yyvstop+202,
yycrank+213,	yysvec+36,	yyvstop+204,
yycrank+121,	yysvec+52,	yyvstop+207,
yycrank+1101,	yysvec+69,	yyvstop+210,
yycrank+123,	0,		yyvstop+213,
yycrank+2432,	yysvec+44,	yyvstop+215,
yycrank+2444,	0,		0,	
yycrank+2467,	yysvec+159,	0,	
yycrank+2482,	yysvec+44,	yyvstop+218,
yycrank+302,	yysvec+159,	yyvstop+220,
yycrank+2507,	yysvec+159,	yyvstop+223,
yycrank+2519,	yysvec+159,	yyvstop+226,
yycrank+2539,	yysvec+159,	yyvstop+229,
yycrank+2552,	yysvec+44,	yyvstop+231,
yycrank+2577,	yysvec+159,	yyvstop+234,
yycrank+2589,	yysvec+159,	yyvstop+237,
yycrank+2609,	yysvec+159,	yyvstop+240,
0,	0,	0};
struct yywork *yytop = yycrank+2666;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,'"' ,01  ,01  ,01  ,01  ,01  ,
'(' ,'(' ,'(' ,'(' ,01  ,'(' ,'(' ,01  ,
'0' ,'0' ,'2' ,'2' ,'2' ,'5' ,'6' ,'6' ,
'6' ,'6' ,'(' ,01  ,01  ,01  ,'>' ,'(' ,
01  ,'A' ,'A' ,'C' ,'D' ,'E' ,'A' ,'G' ,
'G' ,'I' ,'G' ,'G' ,'L' ,'G' ,'N' ,'O' ,
'G' ,'G' ,'R' ,'G' ,'T' ,'U' ,'G' ,'G' ,
'X' ,'Y' ,'G' ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'C' ,'D' ,'E' ,'A' ,'G' ,
'G' ,'I' ,'G' ,'G' ,'L' ,'G' ,'N' ,'O' ,
'G' ,'G' ,'R' ,'G' ,'T' ,'U' ,'G' ,'G' ,
'X' ,'Y' ,'G' ,'(' ,'(' ,'(' ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ifndef lint
static	char ncform_sccsid[] = "@(#)ncform 1.6 88/02/08 SMI"; /* from S5R2 1.2 */
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
